package com.yaohun.aurechargedata.cmd;

import com.yaohun.aurechargedata.Main;
import com.yaohun.aurechargedata.api.ConsumeAPI;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.command.TabCompleter;
import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

public class DataMigrationCmd implements CommandExecutor , TabCompleter {
    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {
        if(!sender.isOp()){return true;}
        if(args.length == 0){
            sender.sendMessage("§r");
            sender.sendMessage("§e------- ======= §6数据迁移管理 §e======= -------");
            sender.sendMessage("§2/apaydata DemonRechargeOrConsume §f- §2迁移消费数据至本插件");
            sender.sendMessage("§e------- ======= §6数据迁移管理 §e======= -------");
            sender.sendMessage("§r");
            return true;
        }
        if(args.length == 1 && args[0].equalsIgnoreCase("DemonRechargeOrConsume")){
            sender.sendMessage("§a插件数据正在统计...");
            Bukkit.getScheduler().runTaskLater(Main.plugin, () -> {
                File file = new File("./plugins/DemonRechargeOrConsume","config.yml");
                FileConfiguration yml = YamlConfiguration.loadConfiguration(file);
                ConfigurationSection section = yml.getConfigurationSection("PlayerData");
                if(section == null){
                    sender.sendMessage("§c未检测到PlayerData相关数据.");
                    return;
                }
                Bukkit.getScheduler().runTaskLater(Main.plugin, () -> {
                    int amount = 0;
                    for (String name : section.getKeys(false)) {
                        int consume = section.getInt(name+".consume");
                        sender.sendMessage("§a已导入消费数据: §f"+name+" ---> "+consume);
                        ConsumeAPI.setConsumeData(name,consume);
                        amount++;
                    }
                    sender.sendMessage("§a已导入数据§e["+amount+"]§a条");
                }, (long) 10);
            }, (long) 10);
        }
        return false;
    }

    @Override
    public List<String> onTabComplete(CommandSender sender, Command command, String label, String[] args) {
        List<String> completions = new ArrayList<>();
        if(args.length == 1){
            completions.add("DemonRechargeOrConsume");
        }
        return completions;
    }
}
